package edu.duke.cs.smlr.factories;

import edu.duke.cs.smlr.learn.classifiers.DefaultClassifier;
import edu.duke.cs.smlr.learn.interfaces.IClassifier;

/**A factory used to make classifiers.  Not really necessary since
 * currently we have only one classifier, but included to make future
 * expansion slightly less painful.
 * 
 * @author Matt Edwards, Jason Bosko
 */

public class ClassifierFactory {

    /**
     * Returns the classifier specified by <b>whichClassifier</b>. Currently only one classifier available.
     * @param whichClassifier The classifier to use.
     * @return The classifier specified by <b>whichClassifier</b>
     */
	public static IClassifier makeClassifier(int whichClassifier) {
        return new DefaultClassifier();
    }
}
