package edu.duke.cs.smlr.factories;

import edu.duke.cs.smlr.learn.interfaces.IMatrix;
import edu.duke.cs.smlr.util.matrix.CernMatrix;

/**A factory for creating matrices.  Not sure if it's necessary /
 * kosher now that our matrices can clone themselves... but hey.
 * 
 * @author Matt Edwards, Jason Bosko
 */

public class MatrixFactory {

    /**
     * Creates a CernMatrix of size zero by zero.
     * @return a CernMatrix of size zero by zero
     */
	public static IMatrix makeMatrix() {
        return new CernMatrix(0, 0);
    }
    
    /**
     * Creates a CernMatrix of size <b>r</b> by <b>c</b>.
     * @param r The number of rows in the new matrix
     * @param c The number of columns in the new matrix
     * @return a CernMatrix of size <b>r</b> by <b>c</b>.
     */
	public static IMatrix makeMatrix(int r, int c) {
        return new CernMatrix(r, c);
    }

}
