package edu.duke.cs.smlr.gui.frames;

import java.awt.BorderLayout;
import java.awt.Color;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;

import edu.duke.cs.smlr.Graphical;

/**
 * The frame used to display the "About" information
 * 
 * @author Jason Bosko, Matt Edwards
 */
public class AboutFrame extends AbstractFrame {
	
	/**
	 * Constructs an AboutFrame.
	 * @param p The GUI
	 */
	public AboutFrame(Graphical p) {
		super(p);
		frame.setTitle("About SMLR");
		frame.setResizable(false);
		frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		frame.getContentPane().setBackground(Color.WHITE);

		//use the classloader to make it load from within a jar file
		ImageIcon picture = new ImageIcon(this.getClass().getResource("/about.jpg"));
		JLabel label = new JLabel(picture);
	      
		int w = picture.getIconWidth() + 4;
		int h = picture.getIconHeight() + 25;
		frame.setSize(w, h);
		frame.getContentPane().add(label, BorderLayout.CENTER);

		center();
	}
}
