package edu.duke.cs.smlr.gui.help;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;

/**A class that creates a help button.  The button is linked to its
 * message by the constructor and automatically has a listener that
 * pops up the help text when it's clicked.
 * 
 * @author Jason Bosko
 */
public class HelpButton extends JButton implements ActionListener {
	int helpConstant;
	
	/**
	 * Constructs a help button specific to the help topic specified by <b>helpConstant</b>
	 * @param helpConstant The constant associated with a specific help topic.
	 */
	public HelpButton(int helpConstant) {
		super("?");
		this.helpConstant = helpConstant;
		this.setToolTipText("Click for help");
		//this.setPreferredSize(new Dimension(75, 30));
		//this.setBorder(BorderFactory.createRaisedBevelBorder());
		//this.setBackground(new Color(200,200,255));
		this.addActionListener(this);
	}
	
	public void actionPerformed(ActionEvent e) {
		Help.createHelpDisplay(helpConstant);
	}
}
