package edu.duke.cs.smlr.gui.panels;

import javax.swing.JPanel;

import edu.duke.cs.smlr.Graphical;

/**The base class for the panel classes used in the graphical interface.
 * All panels used in the graphical interface inherit from this class, which
 * provides a few convenience methods used by many panels.  This class contains
 * a JPanel as a protected member, but does not inherit from it directly. 
 * 
 * @see JPanel
 * 
 * @author Matt Edwards, Jason Bosko
 */

public abstract class AbstractPanel {

    protected JPanel panel;
    protected Graphical parent;
    
    protected AbstractPanel(Graphical g) {
        parent = g;
        panel = new JPanel();
        panel.setEnabled(true);
    }
    
    /**
     * Gets the panel contained in the class.
     * @return The panel
     */
    public JPanel getPanel() {
        return panel;
    }
}
