package edu.duke.cs.smlr.gui.table;

import java.awt.Component;

import javax.swing.JTable;
import javax.swing.JToggleButton;
import javax.swing.SwingConstants;

/**A renderer for use with tables that renders Boolean values with the toggle button
 * that is passed to the constructor on creation. <br>
 * Note: this extends AlternatingRowRenderer so it also alternates row background
 * colors.
 * @author Matt Edwards
 */

public class BooleanRenderer extends AlternatingRowRenderer {
    
    protected JToggleButton checkbox;
    
    public BooleanRenderer(JToggleButton cb) {
        super();
        checkbox = cb;
        checkbox.setHorizontalAlignment(SwingConstants.CENTER);
    }
    
    /* (non-Javadoc)
     * @see javax.swing.table.TableCellRenderer#getTableCellRendererComponent(javax.swing.JTable, java.lang.Object, boolean, boolean, int, int)
     */
    public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
        checkbox.setSelected(((Boolean) value).booleanValue());
        
        this.setAlternatingBackground(checkbox, table, isSelected, hasFocus, row, column);               
        
        return checkbox;
    }
}