package edu.duke.cs.smlr.learn;

import java.io.PrintWriter;

import edu.duke.cs.smlr.learn.interfaces.IMatrix;
import edu.duke.cs.smlr.learn.properties.LearnProperty;
import edu.duke.cs.smlr.learn.properties.TestProperty;

/**
 * Writes a classifier out to a file in a special classifier format. This is not included in the current release (1.0.1)
 * @author Jason Bosko, Matt Edwards
 *
 */
public class ClassifierWriter {
	private ClassifierWriter() {}
	
	public static void writeClassifier(TestProperty weights, LearnProperty info, PrintWriter output) {		
		IMatrix w = weights.getWeights();
		//double delta = info.getKillThreshold();
		
		output.println("*** Parameters that produced this set of weights ***");
		output.println(info.toString());
		output.println("*** End of parameters that produced this set of weights ***");
		output.println("$ " + w.numRows() + " " + w.numCols());
		for (int i = 0; i < w.numRows(); ++i) {
			output.print("> ");
			for (int j = 0; j < w.numCols(); ++j)
				//if (Math.abs(w.get(i, j) >= delta))
					output.print(w.get(i, j) + " ");
			output.println();
		}
		output.println("*** End of weights ***");
		output.println();		
	}
}
