package edu.duke.cs.smlr.learn.classifiers;

import edu.duke.cs.smlr.factories.MatrixFactory;
import edu.duke.cs.smlr.learn.interfaces.IClassifier;
import edu.duke.cs.smlr.learn.interfaces.IMatrix;

/**
 * A classifier that has a different threshold than 50%.
 * 
 * Currently set at 90% (must be 90% sure to be class one)
 * 
 * @author Matt Edwards
 */
public class BiasedClassifier extends DefaultClassifier implements IClassifier {

	public IMatrix classifications(IMatrix x, IMatrix w) {
//		System.out.println("Using adjusted classifier.");
		IMatrix temp = probabilities(x, w);
		IMatrix ans = MatrixFactory.makeMatrix(temp.numRows(), 1);
		for (int i = 0; i < temp.numRows(); ++i)
			if (temp.get(i, 0) > 0.90)
				ans.set(0, i, 0);
			else
				ans.set(1, i, 0);

		return ans.add(1); // convert to 1-based
	}

}
