package edu.duke.cs.smlr.learn.interfaces;

import java.io.FileNotFoundException;

/**
 * An interface for reading and returning data for learning. Goal is to allow
 * different sources and methods of data creation to be interchangeable.  Note:
 * this interface is now pretty useless as the only reader is AdaptiveReader, whose
 * goal is to read anything useful.  Therefore, we'll mark it as deprecated and include
 * it only for historical value.
 * 
 * @deprecated 
 * 
 * @author Jason Bosko, Matt Edwards
 */
public interface IReader {

	/**
	 * Reads data from the specified file
	 * 
	 * @param filename name of the file to read from
	 */
	public void read(String filename) throws FileNotFoundException;

	/**
	 * Gets the matrix of test data (features) should return a copy that can be
	 * modified without problems
	 * 
	 * @return X, the matrix
	 */
	public IMatrix getX(); //maybe this shouldn't be modifiable to save memory

	/**
	 * Gets the matrix of test data classifications should return a copy that
	 * can be modified without problems
	 * 
	 * @return Y, the matrix
	 */
	public IMatrix getY();

	/**
	 * @return the number of test data cases
	 */
	public int getN();

	/**
	 * @return the number of test data features
	 */
	public int getD();

	/**
	 * @return the number of test data classifications
	 */
	public int getM();
}
