package edu.duke.cs.smlr.learn.kernels;

import edu.duke.cs.smlr.learn.interfaces.IKernel;
import edu.duke.cs.smlr.learn.interfaces.IMatrix;

/**
 * Computes a linear kernel
 * 
 * @author Jason Bosko, Matt Edwards
 * 
 */

public class LinearKernel extends AbstractKernel implements IKernel {

	public IMatrix computeKernel(IMatrix X1, IMatrix X2, Object useless,
			double bias, boolean normalize) {
		if (normalize) {
			X1 = normalizeTest(X1, X2);
			X2 = normalizeTrain(X2, X2);
		}
		
		IMatrix temp = X1.mult(X2.copy().transpose());
		return addBias(temp, bias);
	}

}
