package edu.duke.cs.smlr.learn.kernels;

import edu.duke.cs.smlr.learn.interfaces.IKernel;
import edu.duke.cs.smlr.learn.interfaces.IMatrix;

/**
 * Computes a polynomial kernel
 * 
 * @author Jason Bosko, Matt Edwards
 * 
 */
public class PolynomialKernel extends AbstractKernel implements IKernel {

	public IMatrix computeKernel(IMatrix X1, IMatrix X2, Object kernelPar,
			double bias, boolean normalize) {
		double power = 1;
		if (kernelPar != null) {
			try {
				power = ((Double) kernelPar).intValue();
			} catch (ClassCastException e) {
			}
		}
		if (normalize) {
			X1 = normalizeTest(X1, X2);
			X2 = normalizeTrain(X2, X2);
		}
		IMatrix temp = X1.mult(X2.copy().transpose()).add(1).termPow(power);
		return addBias(temp, bias);
	}

}
