package edu.duke.cs.smlr.learn.kernels;

import edu.duke.cs.smlr.factories.MatrixFactory;
import edu.duke.cs.smlr.learn.interfaces.IKernel;
import edu.duke.cs.smlr.learn.interfaces.IMatrix;

/**
 * Computes a Full Radial Base Function (RBFfull) kernel.  This is never
 * used in the current version of the program, but included for completeness.
 * Since it's never used and we've never seen examples that use this method, we'll
 * mark it as deprecated since we have no way of verifying it works as intended.
 * 
 * @deprecated
 * 
 * @author Jason Bosko, Matt Edwards
 * 
 */
public class RBFFullKernel extends AbstractKernel implements IKernel {

	public IMatrix computeKernel(IMatrix X1, IMatrix X2, Object kernelPar,
			double bias, boolean normalize) {
		
		if (normalize) {
			X1 = normalizeTest(X1, X2);
			X2 = normalizeTrain(X2, X2);
		}		
		
		int N1 = X1.numRows();
		int N2 = X2.numRows();
		int d = X1.numCols();

		double bias2 = 0;
		IMatrix kPar;
		try {
			if (kernelPar == null)
				throw new ClassCastException();
			kPar = (IMatrix) kernelPar;
		} catch (ClassCastException e) {
			// use properly-sized identity as default
			kPar = MatrixFactory.makeMatrix(X1.numRows(), 1).add(1).diag();
		}
		IMatrix weights;
		int rows = kPar.numRows();
		int cols = kPar.numCols();
		if (rows == 1 && cols == d)
			weights = kPar.diag();
		else if ((rows == 1) && (cols == d + 1)) {
			weights = kPar.chunk(0, 0, 1, d).diag();
			bias2 = kPar.get(0, d);
		} else if ((rows == d) && (cols == 1))
			weights = kPar.diag();
		else if ((rows == d + 1) && (cols == 1)) {
			weights = kPar.chunk(0, 0, d, 1).diag();
			bias2 = kPar.get(d, 0);
		} else if ((rows == d) && (cols == d))
			weights = kPar;
		else {
			System.err.println("KernelPar does not match the chosen kernel: RBFFull");
			return null;
		}
		//this is really nasty here... [but does it matter since it isn't used?]
		IMatrix part1 = X1.copy().termPow(2).mult(weights).mult(
				MatrixFactory.makeMatrix(d, N2).add(1));
		IMatrix part2 = MatrixFactory.makeMatrix(N1, d).add(1).mult(weights).mult(
				X2.copy().termPow(2).transpose());
		IMatrix part3 = X1.copy().mult(2).mult(X2.copy().transpose());
		IMatrix dist = part1.add(part2).add(part3.mult(-1));
		IMatrix K = dist.mult(-1 / (double) d).add(bias2).exp();
		return addBias(K, bias);
	}
}
