package edu.duke.cs.smlr.learn.properties;

/**Encapsulates the settings for displaying information from various properties.
 * 
 * @deprecated
 * 
 * @author Jason Bosko, Matt Edwards
 */
public class DisplayProperty {
	// Display flags from LearnResult
	private boolean displayWeights = true;
	private boolean displayIters = true;
	private boolean displayBasisUsed = true;
	private boolean displayTime = true;

	// Display flags from TestResult
	private boolean displayProbabilities = true;
	private boolean displayClassifications = true;
	private boolean displayNumWrong = true;
	private boolean displayNumCorrect = true;
	private boolean displayPercentage = true;
	private boolean displayMisclassifications = true;
	
	// Display flags from KFoldResult
	private boolean displayTotalCorrect = true;
	private boolean displayTotalIncorrect = true;
	private boolean displayTotalPercentage = true;
	private boolean displayAverageWeights = true;
	private boolean displayWeightCounts = true;
	private boolean displayAverageWeightCounts = true;

	/**
	 * @return Returns the displayBasisUsed.
	 */
	public boolean isDisplayBasisUsed() {
		return displayBasisUsed;
	}

	/**
	 * @param displayBasisUsed
	 *            The displayBasisUsed to set.
	 */
	public void setDisplayBasisUsed(boolean displayBasisUsed) {
		this.displayBasisUsed = displayBasisUsed;
	}

	/**
	 * @return Returns the displayClassifications.
	 */
	public boolean isDisplayClassifications() {
		return displayClassifications;
	}

	/**
	 * @param displayClassifications
	 *            The displayClassifications to set.
	 */
	public void setDisplayClassifications(boolean displayClassifications) {
		this.displayClassifications = displayClassifications;
	}

	/**
	 * @return Returns the displayIters.
	 */
	public boolean isDisplayIters() {
		return displayIters;
	}

	/**
	 * @param displayIters
	 *            The displayIters to set.
	 */
	public void setDisplayIters(boolean displayIters) {
		this.displayIters = displayIters;
	}

	/**
	 * @return Returns the displayNumCorrect.
	 */
	public boolean isDisplayNumCorrect() {
		return displayNumCorrect;
	}

	/**
	 * @param displayNumCorrect
	 *            The displayNumCorrect to set.
	 */
	public void setDisplayNumCorrect(boolean displayNumCorrect) {
		this.displayNumCorrect = displayNumCorrect;
	}

	/**
	 * @return Returns the displayNumWrong.
	 */
	public boolean isDisplayNumWrong() {
		return displayNumWrong;
	}

	/**
	 * @param displayNumWrong
	 *            The displayNumWrong to set.
	 */
	public void setDisplayNumWrong(boolean displayNumWrong) {
		this.displayNumWrong = displayNumWrong;
	}

	/**
	 * @return Returns the displayPercentage.
	 */
	public boolean isDisplayPercentage() {
		return displayPercentage;
	}

	/**
	 * @param displayPercentage
	 *            The displayPercentage to set.
	 */
	public void setDisplayPercentage(boolean displayPercentage) {
		this.displayPercentage = displayPercentage;
	}

	/**
	 * @return Returns the displayProbabilities.
	 */
	public boolean isDisplayProbabilities() {
		return displayProbabilities;
	}

	/**
	 * @param displayProbabilities
	 *            The displayProbabilities to set.
	 */
	public void setDisplayProbabilities(boolean displayProbabilities) {
		this.displayProbabilities = displayProbabilities;
	}

	/**
	 * @return Returns the displayTime.
	 */
	public boolean isDisplayTime() {
		return displayTime;
	}

	/**
	 * @param displayTime
	 *            The displayTime to set.
	 */
	public void setDisplayTime(boolean displayTime) {
		this.displayTime = displayTime;
	}

	/**
	 * @return Returns the displayWeights.
	 */
	public boolean isDisplayWeights() {
		return displayWeights;
	}

	/**
	 * @param displayWeights
	 *            The displayWeights to set.
	 */
	public void setDisplayWeights(boolean displayWeights) {
		this.displayWeights = displayWeights;
	}
	
	/**
	 * @return Returns the displayAverageWeightCounts.
	 */
	public boolean isDisplayAverageWeightCounts() {
		return displayAverageWeightCounts;
	}
	/**
	 * @param displayAverageWeightCounts The displayAverageWeightCounts to set.
	 */
	public void setDisplayAverageWeightCounts(boolean displayAverageWeightCounts) {
		this.displayAverageWeightCounts = displayAverageWeightCounts;
	}
	/**
	 * @return Returns the displayAverageWeights.
	 */
	public boolean isDisplayAverageWeights() {
		return displayAverageWeights;
	}
	/**
	 * @param displayAverageWeights The displayAverageWeights to set.
	 */
	public void setDisplayAverageWeights(boolean displayAverageWeights) {
		this.displayAverageWeights = displayAverageWeights;
	}
	/**
	 * @return Returns the displayTotalCorrect.
	 */
	public boolean isDisplayTotalCorrect() {
		return displayTotalCorrect;
	}
	/**
	 * @param displayTotalCorrect The displayTotalCorrect to set.
	 */
	public void setDisplayTotalCorrect(boolean displayTotalCorrect) {
		this.displayTotalCorrect = displayTotalCorrect;
	}
	/**
	 * @return Returns the displayTotalIncorrect.
	 */
	public boolean isDisplayTotalIncorrect() {
		return displayTotalIncorrect;
	}
	/**
	 * @param displayTotalIncorrect The displayTotalIncorrect to set.
	 */
	public void setDisplayTotalIncorrect(boolean displayTotalIncorrect) {
		this.displayTotalIncorrect = displayTotalIncorrect;
	}
	/**
	 * @return Returns the displayWeightCounts.
	 */
	public boolean isDisplayWeightCounts() {
		return displayWeightCounts;
	}
	/**
	 * @param displayWeightCounts The displayWeightCounts to set.
	 */
	public void setDisplayWeightCounts(boolean displayWeightCounts) {
		this.displayWeightCounts = displayWeightCounts;
	}
	
	/**
	 * @return Returns the displayTotalPercentage.
	 */
	public boolean isDisplayTotalPercentage() {
		return displayTotalPercentage;
	}
	/**
	 * @param displayTotalPercentage The displayTotalPercentage to set.
	 */
	public void setDisplayTotalPercentage(boolean displayTotalPercentage) {
		this.displayTotalPercentage = displayTotalPercentage;
	}
	
	/**
	 * @return Returns the displayMisclassifications.
	 */
	public boolean isDisplayMisclassifications() {
		return displayMisclassifications;
	}
	/**
	 * @param displayMisclassifications The displayMisclassifications to set.
	 */
	public void setDisplayMisclassifications(boolean displayMisclassifications) {
		this.displayMisclassifications = displayMisclassifications;
	}
}
