package edu.duke.cs.smlr.learn.properties;

import java.util.ArrayList;
import java.util.Iterator;

/**
 * Class for storing what alterations should be performed on a dataset: row or
 * column removals, normalization, etc.
 * 
 * @author Matt Edwards, Jason Bosko
 */
public class ModifyProperty {
	private ArrayList deletedRows;
	private ArrayList deletedColumns;

	private boolean display = true;

	public ModifyProperty() {
		deletedRows = new ArrayList();
		deletedColumns = new ArrayList();
	}

	public String toString() {
		if (!display)
			return "";
		String s = "";
		final String sep = "\n";
		boolean needsep = false;
		if (deletedRows.size() > 0) {
			s += "Deleted rows: [ ";
			for (Iterator it = deletedRows.iterator(); it.hasNext();)
				s += it.next().toString() + " ";
			s += "]";
			needsep = true;
		}
		if (deletedColumns.size() > 0) {
			if (needsep) s += sep;
			s += "Deleted columns (zero-based): [ ";
			for (Iterator it = deletedColumns.iterator(); it.hasNext();)
				s += it.next().toString() + " ";
			s += "]" + sep;
		}
	
		return s;
	}

	/**
	 * @return Returns the display.
	 */
	public boolean isDisplay() {
		return display;
	}

	/**
	 * @param display
	 *            The display to set.
	 */
	public void setDisplay(boolean display) {
		this.display = display;
	}

	/**
	 * @return Returns the deletedColumns.
	 */
	public ArrayList getDeletedColumns() {
		return deletedColumns;
	}

	/**
	 * @return Returns the deletedRows.
	 */
	public ArrayList getDeletedRows() {
		return deletedRows;
	}

}
