package edu.duke.cs.smlr.learn.results;

import edu.duke.cs.smlr.learn.interfaces.IMatrix;
import edu.duke.cs.smlr.util.ClassificationMap;
import edu.duke.cs.smlr.util.DataPointMap;

/**
 * Class that stores the results from a single learning task
 * 
 * @author Matt Edwards, Jason Bosko
 */
public class LearnResult {
	
	private ClassificationMap classificationMap;
	private DataPointMap trainMap;
	
	private IMatrix weights;
	private int iterations;
	private int basisUsed;
	private double time;


//	public String toString() {
//		String s = "";
//		String sep = "\n";
//		if (displayWeights) {
//			s += "Weights: \n" + weights.toString() + sep;
//			//HERE
//		}
//		if (displayIters)
//			s += "Iterations: " + iterations + sep;
//		if (displayBasisUsed)
//			s += "Total Basis Functions Used: " + basisUsed + sep;
//		if (displayTime)
//			s += "Time Elapsed: " + time + " sec" + sep;
//		return s;
//	}


	/**
	 * @return Returns the basisUsed.
	 */
	public int getBasisUsed() {
		return basisUsed;
	}

	/**
	 * @param basisUsed
	 *            The basisUsed to set.
	 */
	public void setBasisUsed(int basisUsed) {
		this.basisUsed = basisUsed;
	}

	/**
	 * @return Returns the iterations.
	 */
	public int getIterations() {
		return iterations;
	}

	/**
	 * @param iterations
	 *            The iterations to set.
	 */
	public void setIterations(int iterations) {
		this.iterations = iterations;
	}

	/**
	 * @return Returns the weights.
	 */
	public IMatrix getWeights() {
		return weights;
	}

	/**
	 * @param weights
	 *            The weights to set.
	 */
	public void setWeights(IMatrix weights) {
		this.weights = weights;
	}

	/**
	 * @return Returns the time.
	 */
	public double getTime() {
		return time;
	}

	/**
	 * @param time
	 *            The time to set.
	 */
	public void setTime(double time) {
		this.time = time;
	}

	public void setClassificationMap(ClassificationMap classificationMap) {
		this.classificationMap = classificationMap;
	}
	public void setTrainMap(DataPointMap trainMap) {
		this.trainMap = trainMap;
	}
	
	public ClassificationMap getClassificationMap() {
		return classificationMap;
	}
	public DataPointMap getTrainMap() {
		return trainMap;
	}
	
	
}
