package edu.duke.cs.smlr.util;
/**
 * Contains all of the default settings for SMLR 
 * 
 * @author Jason Bosko
 *
 */
public class Defaults {
	
	public static final int 	BEHAVIOR = Constants.TEST_LOOCV;
	
	public static final int 	KERNEL = Constants.KERNEL_DIRECT;
	public static final int 	ALGORITHM = Constants.ALGORITHM_COMPONENT;
	public static final int 	PRIOR = Constants.PRIOR_LAPLACIAN;
	
	public static final boolean NORMALIZE = true;
	public static final double  BIAS = 1;
	
	public static final int 	k = 5;
	public static final int 	RANDOMIZATION = Constants.KFOLD_RATIO_RANDOM;
	public static final int 	CLASS_LABELS = Constants.READER_GUESS;
	
	public static final double 	KERNEL_POLY_PARAM = 2;
	public static final double 	KERNEL_RBF_PARAM = 2;
	public static final double 	LAMBDA = 0.1;
	
	public static final int 	VIEW_ROWS_TOTAL = 10;
	public static final int 	VIEW_ROWS_START = 1;
	public static final int 	VIEW_COLS_TOTAL = 10;
	public static final int 	VIEW_COLS_START = 1;
	
	public static final boolean	PREFS_LEARN_WEIGHTS = false;
	public static final boolean	PREFS_LEARN_ITERS = true;
	public static final boolean	PREFS_LEARN_BASES= true;
	public static final boolean	PREFS_LEARN_TIME = true;
	
	public static final boolean	PREFS_TEST_PROBS = false;
	public static final boolean	PREFS_TEST_CLASSES = false;
	public static final boolean	PREFS_TEST_WRONG = true;
	public static final boolean	PREFS_TEST_CORRECT = true;
	public static final boolean	PREFS_TEST_PERCENT = true;
	public static final boolean	PREFS_TEST_MISCLASS = true;
	
	public static final boolean	PREFS_CROSS_CORRECT = true;
	public static final boolean	PREFS_CROSS_INCORRECT = true;
	public static final boolean	PREFS_CROSS_PERCENT = true;
	public static final boolean	PREFS_CROSS_AVGWEIGHT = false;
	public static final boolean	PREFS_CROSS_WEIGHTCOUNT = false;
	public static final boolean	PREFS_CROSS_NONZERO = false;
	public static final boolean	PREFS_CROSS_CONFUSION = true;
	public static final boolean	PREFS_CROSS_ROC = true;
	
	public static final double 	PREFS_CONVTOL = 0.0001;
	public static final double 	PREFS_KILLTHRESH = 0.000001;
	public static final int 	PREFS_MAXITER = 10000;
	
	public static final boolean PREFS_OVERRELAX = false;
	public static final boolean PREFS_CACHEEXP = true;
	public static final boolean PREFS_CACHEKERNEL = true;
}
