package edu.duke.cs.smlr.util;

import cern.jet.random.engine.MersenneTwister;

/**A fast random number generator class using the Mersenne Twister algorithm from the CERN Jet
 * library.
 * 
 * @author Matt Edwards
 */

public final class FastRandom {
    private static final MersenneTwister twister = new MersenneTwister(new java.util.Date());
    
    /**
     * @return a pseudorandom double [strictly] between 0.0 and 1.0
     */
    public static double random() {
        //return Math.random();
        return twister.raw();
    }
}
