package edu.duke.cs.smlr.util;

/**
 * A static class that contains messages used in SMLR.  It is still growing as more
 * strings get externalized into this file.
 * 
 * @author Jason Bosko, Matt Edwards
 */
public class Messages {	
	
	// Miscellaneous
	
	public static String NOTIFY_ONE_POSSIBLE_TEST = "You have selected one test to run.";
	public static String NOTIFY_TESTS_CHOSEN = "To save time, you can deselect tests to run if you wish.";
	public static String DATA_NOT_LOADED = "No data has been loaded.  Please return to the task panel.";
	public static String DATA_LOADING = "Loading Data...";

	//Titles
	
	public static String TITLE_MAIN = "SMLR";
	public static final String TITLE_DATA_TRAIN = "Training Data";
	public static final String TITLE_DATA_TEST = "Testing Data";
	public static final String TITLE_DATA_UNLABELED = "Unlabeled Data";
	public static String TITLE_TASK = "Specify Task";
	public static String TITLE_DATA = "Manipulate Data";
	public static String TITLE_METHODS = "Select Methods";
	public static String TITLE_CHOOSE = "Review Selections";
	
	//Tooltips
	
	public static String TOOLTIP_TASK = "Specify the classification task and data";
	public static String TOOLTIP_DATA = "View the data and modify it if needed";
	public static String TOOLTIP_METHODS = "Select methods, kernels, and priors";
	public static String TOOLTIP_CHOOSE = "Review the classifiers to be learned";
	public static final String TOOLTIP_DATA_TRAIN = "View and modify the training data, if needed";
	public static final String TOOLTIP_DATA_TEST = "View and modify the testing data, if needed";
	public static final String TOOLTIP_DATA_UNLABELED = "View and modify the unlabeled data, if needed";
	
	//Errors
	
	public static String ERROR_MEMORY = "Error: SMLR does not have enough memory to learn this task.  Please run it" +
            				"with a larger maximum heap size, or choose a smaller dataset.";
	
	public static String ERROR_DATA_LOAD = "Error: Unable to read data file.";
	public static String ERROR_MUST_BE_POSITIVE = "Please select a positive number.";
	public static String ERROR_COMMA_LIST = "Please use a comma-separated list.";
	
	public static String ERROR_FILE_FORMAT = "Error: Invalid format in data file.  Fix the format of this file or try another file.";
	public static String ERROR_FILE_FORMAT_TITLE = "Loading Error";
	
	public static String ERROR_SAVING_FILE = "Error: Can't write to file.  Try using a different file.";
	public static String ERROR_SAVING_FILE_TITLE = "Saving Error";
	
	public static String ERROR_FILE_NOT_FOUND = "Error: The file was not found.";
	public static String ERROR_READING_FILE = "Error: Problems encountered while reading file.";
	public static String ERROR_NO_SAVETO = "Error: No file to which to save results.";
	
	public static final String ERROR_NO_KEY = "There is no classification key because the data is unlabeled.";
	public static final String ERROR_NO_KEY_TITLE = "No Classification Key";
		
	//Success messages
	
	public static String SUCCESS_SAVING_SETTINGS = "Settings file saved successfully.";
	public static String SUCCESS_SAVING_SETTINGS_TITLE = "Save Successful";
	
	//Menu items
	
	public static String MENU_FILE = "File";
	public static String MENU_PREFERENCES = "Preferences";
	
	//Help messages
	
	public static String TASK_HELP = 
		"<b>Learn & Evaluate Classifier</b>: Learn a classifier "+
		"based on labeled examples in a training data file, and "+
		"then evaluate the accuracy of the classifier either using "+
		"labeled examples in a test data file or some form of "+
		"cross validation.<br><br>"+
		"<b>Learn & Use Classifier</b>: Learn a classifier based "+
		"on labeled examples in a training data file, and then "+
		"use the classifier to classify a set of unlabeled "+
		"examples.";
	
	public static String TRAINING_DATA_HELP	= 
		"<b>Use Training Data</b>: The training data file is "+
		"required and contains the labeled examples that are "+
		"used to learn a classifier.  The file should have one "+
		"row for each labeled example, with entries separated "+
		"by spaces.<br><br>"+
		"<b>Column with Class Labels</b>: Select the column that "+
		"contains the class label for each example training "+
		"data.<br>"+
		"<i>Guess</i>: Guess between the first and last column, "+
		"based on which has fewer unique values.<br>"+
		"<i>First</i>: Assume the first column contains the class "+
		"label.<br>"+
		"<i>Last</i>: Assume the last column contains the class "+
		"label.<br>"+
		"<i>Choose:</i>: Allow the user to choose which column "+
		"contains the class label.";
	
	public static String EVALUATION_OPTIONS_HELP = 
		"<b>Use Test Data</b>: Indicates that the generalization of the "+
		"classifier learned from the training data is to be evaluated "+
		"by observing its accuracy on a set of labeled test data which "+
		"has been held out when learning the classifier.  The user must "+
		"specify the test data file, which should have one row for each "+
		"labeled example, with entries separated by spaces.<br><br>"+
		"<b>Leave-One-Out Cross Validation (LOOCV)</b>: Indicates that "+
		"the generalization of the classifier should be evaluated by "+
		"a cross validation test in which one example is held out when "+
		"learning the classifier; the classifier so learned is then "+
		"used to classify the held-out example.  This is repeated for "+
		"every example in the training set, so while it is a fairly "+
		"accurate measure of a classifier's ability to generalize to "+
		"unseen data, it can be quite time consuming.<br><br>"+
		"<b>K-Fold Cross Validation</b>: Indicates that the "+
		"generalization of the classifier should be evaluated by a "+
		"cross validation test in which the training data are "+
		"partitioned into K equally-sized subsets and then one subset "+
		"is held out when learning the classifier; the classifier "+
		"so learned is then used to classify the held-out subset.  "+
		"Since this requires only K separate classifiers to be "+
		"learned, it can be much faster than LOOCV.  If no value of K is" +
		"specified, 5 is used by default.<br>"+
		"<i>Randomization: Within Classes</i>: When selecting the K "+
		"subsets for K-fold cross validation, do so at random but "+
		"ensure that each class is represented in each subset in the "+
		"same proportion as in the full training set.<br>"+
		"<i>Randomization: Across Classes</i>: When selecting the K "+
		"subsets for K-fold cross validation, do so at random but "+
		"partition without regard to class membership.<br>"+
		"<i>Randomization: None</i>: When selecting the K subsets for "+
		"K-fold cross validation, do so sequentially (not at random) "+
		"based on the order of examples in the training data file.";
	
	public static String USE_OPTIONS_HELP = 
		"<b>Load Unlabeled Data</b>: Unlabeled data contains only "+
		"features (the class labels are unknown).  The classifier "+
		"learned from the labeled training data will be applied to "+
		"the unlabeled data, and the class predictions will be saved "+
		"to a file (chosen by the user later, in the output panel).";
	
	public static String OBSERVATIONS_HELP = 
		"<b>Examples</b>: The number of examples contained in the "+ 
		"data.<br><br>"+
		"<b>Features</b>: The number of features contained in the "+
		"data.<br><br>"+
		"<b>Classes</b>: The number of (unique) class labels "+
		"contained in the data.";
		
	public static String DELETE_ROW_COLUMN_HELP =  
		"<b>Delete Row(s)</b>: Examples can be removed from "+
		"consideration by the classfier learning procedure.  If "+
		"this is desired, simply enter the indices of the row(s) "+
		"to be deleted, as a space- or comma-separated list.<br><br>"+
		"<b>Delete Column(s)</b>: Features can be removed from "+
		"consideration by the classfier learning procedure.  If "+
		"this is desired, simply enter the indices of the column(s) "+
		"to be deleted, as a space- or comma-separated list.<br><br>";
	
	public static String DATA_WINDOW_HELP = 
		"<b>Rows to View</b>: The number of rows to be displayed in "+
		"the data table in this panel.  Note that this has no "+
		"effect on the data to be used during classifier learning; it "+
		"simply affects the volume of data being displayed in this "+
		"panel.<br><br>"+
		"<b>Start Row</b>:  The row index at which the data table in "+
		"this panel will start displaying data.  Note that this has "+
		"no effect on the data to be used during classifier learning; "+
		"it simply affects which data is being displayed in this "+
		"panel.<br><br>"+
		"<b>Columns to View</b>: The number of columns to be displayed "+
		"in the data table in this panel.  Note that this has no "+
		"effect on the data to be used during classifier learning; it "+
		"simply affects the volume of data being displayed in this "+
		"panel.<br><br>"+
		"<b>Start Column</b>: The column index at which the data "+
		"table in this panel will start displaying data.  Note that "+
		"this has no effect on the data to be used during classifier "+
		"learning; it simply affects which data is being displayed "+
		"in this panel.<br><br>";
	
	public static String NORMALIZE_HELP = 
		"<b>Normalize</b>: Recenters and rescales each feature to "+
		"have zero mean and unit variance.<br><br>"+
		"<b>Do Not Normalize</b>: Leaves the feature values unaltered "+
		"from how they were specified in the data file.<br><br>"+
		"As with other choice sets in this panel, you may specify "+
		"more than one choice.  If you choose both, a separate set "+
		"of runs will be executed for each choice.";
	
	public static String KERNELS_HELP = 
		"<b>Kernel</b>:  A kernel specifies a mechanism for determining the "+
		"similarity between any pair of examples as a function "+
		"of their features.  If a kernel is employed, then the "+
		"weights learned by SMLR are weights on the kernel basis "+
		"functions associated with the examples.  As a consequence, "+
		"the sparsity-promoting prior encourages sparse utilization "+
		"of these kernel basis functions, resulting in only a small "+
		"set of examples being used in the classifier, much like is "+
		"the case when using a support vector machine (SVM).  Unlike "+
		"the SVM, however, a kernel need not be employed and instead "+
		"SMLR can learn weights directly on the features themselves, "+
		"resulting in sparse feature utilization, or equivalently, "+
		"built-in feature selection.  This option can be selected "+
		"by choosing <i>Direct</i>, which is not a kernel at all "+
		"but applies SMLR directly to weights on the features "+
		"themselves.<br><br>" +
		"<b>Degree of Polynomial Kernel</b>: Chooses the highest degree " +
		"of the polynomial to be used in the kernel function.<br><br>" +
		"<b>Bandwidth of RBF Kernel</b>: Chooses the width of the " +
		"Radial Basis Functions."; 
	
	public static String BIAS_HELP = 
		"<b>Bias</b>: Adds a bias to the features. The bias term is a " +
		"column that is set entirely to a constant value. The default "+
		"value for this constant is 1.0, but can be set to any number. " +
		"This enables the classifier to find a decision boundary that "+
		"does not go through the origin.  It is unnecessary if you "+
		"already have such a feature in your data. You can specify multiple " +
		"values for the bias as a space- or comma-separated list. A bias " +
		"value of zero is the same as selecting 'Do not add bias'";
	
	public static String PRIORS_HELP = 
		"<b>Laplacian</b>: This results in a MAP estimate of the "+
		"weights under a sparsity-promoting l-1 penalty prior.  "+
		"This is the default and recommended choice as it encourages "+
		"sparsity of the learned weights, which is really the whole "+
		"point of SMLR (it isn't SMLR without a Laplacian prior).  "+
		"This is related to LASSO regression in spirit.<br><br>"+ 
		"<b>Gaussian</b>: This results in a MAP estimate of the "+
		"weights under an l-2 penalty prior, which encourages "+
		"shrinkage of the weights, but not sparsity.  This is "+
		"related to ridge regression in spirit.<br><br>"+
		"<b>No Prior</b>: This results in a simple maximum "+
		"likelihood (ML) estimate of the weights, with no shrinkage "+
		"or sparsity.";
	
	public static String SPARSITY_HELP = 
		"<b>Lambda</b> scales the log prior and as such, controls "+
		"the amount of regularization applied to the weights.  With "+
		"a Laplacian prior (SMLR), this controls the sparsity of "+
		"the learned weights; with a Gaussian prior (RMLR), this "+
		"controls the shrinkage.  Lambda must be a positive number.  "+
		"A larger lambda means greater regularization (more sparsity "+
		"or shrinkage).  You can specify multiple values of lambda "+
		"as a space- or comma-separated list.";
	
	public static String UPDATE_RULE_HELP = 
		"<b>Component-Wise</b>: An algorithm in which each element "+
		"of the weight vector is updated one-at-a-time using a simple "+
		"round robin strategy.  As the objective function is convex "+
		"and thus has a unique optimum, this algorithm will converge "+
		"to the same final weight vector as the non-component-wise "+
		"version, but the computational savings may be significant "+
		"with this option when the product of the number of classes "+
		"with the number of features (or number of examples when "+
		"using a kernel) is quite large.<br><br>"+
		"<b>Non-Component-Wise</b>: An algorithm in which all the "+
		"elements of the weight vector are updated at once in each "+
		"iteration.  As the objective function is convex and thus "+
		"has a unique optimum, this algorithm will converge to the "+
		"same final weight vector as the component-wise version, but " +
		"the computational savings may be significant with this " +
		"option when the number of examples is quite large.<br><br>"+
		"The default value is the component-wise algorithm.";
	
	public static String LEARN_DISPLAY_HELP = 
		"<b>Weights</b>: View the weights learned for each test. If there are " +
		"<b>m</b> unique classes, then each feature will have <b>m-1</b> weights " +
		"on it.<br><br>"+
		"<b>Iterations</b>: View the number of iterations required "+
		"before convergence while learning the weights.<br><br>"+
		"<b>Number of bases</b>: View the number of features (or kernel "+
		"basis functions) that are non-zero in the final weight vector."+
		"<br><br>"+
		"<b>Time Elapsed</b>: View the amount of time required before "+
		"convergence while learning the weights.";
	
	public static String TEST_DISPLAY_HELP = 
		"<b>Probabilities</b>: View the probability associated with the "+
		"most probable class label predicted for each test example.<br><br>"+
		"<b>Classifications</b>: View the most probable class label "+
		"predicted for each test example.<br><br>"+ 
		"<b>Number Wrong</b>: View the number of incorrect "+
		"classifications during testing.<br><br>"+
		"<b>Number Correct</b>: View the number of correct "+
		"classifications during testing.<br><br>"+
		"<b>Percentage</b>: View the percentage of classifications that "+
		"were correct during testing.<br><br>"+ 
		"<b>Misclassifications</b>: View the test examples that were "+
		"misclassified during testing, what they were misclassified as, "+
		"and what their real classifications were.";
	
	public static String KFOLD_DISPLAY_HELP = 
		"<i>These options are only available when K-Fold or LOOCV is "+
		"selected.</i><br><br>"+
		"<b>Total Correct</b>: View the total number of correct "+
		"classifications during the entire set of cross validation "+
		"tests.<br><br>"+
		"<b>Total Incorrect</b>: View the total number of incorrect "+
		"classifications during the entire set of cross validation "+
		"tests.<br><br>"+
		"<b>Total Percentage</b>: View the percentage of classifications "+
		"that were correct during the entire set of cross validation "+
		"tests.<br><br>"+
		"<b>Average Weights</b>: View the average weight for each feature "+
		"during the entire set of cross validation tests. If there are " +
		"<b>m</b> unique classes, then each feature will have <b>m-1</b> " +
		"weights on it.<br><br>"+
		"<b>Weight Counts</b>: View the number of times a weight was "+
		"nonzero during the entire set of cross validation tests. If " +
		"there are <b>m</b> unique classes, then each feature will have " +
		"<b>m-1</b> weights on it.<br><br>"+
		"<b>Nonzero Percentage</b>: View the percentage of times a weight "+
		"was nonzero during the entire set of cross validation tests. If there are " +
		"<b>m</b> unique classes, then each feature will have <b>m-1</b> weights " +
		"on it.<br><br>" +
		"<b>Confusion Matrix</b>: View the matrix that describes the frequency " +
		"with which each observed class is predicated as every other class.<br><br>" +
		"<b>ROC Curve</b>: The ROC (Receiver Operating Characteristic) curve " +
		"is a measure of the sensitivity vs. (1-specificity) for a binary classifier. " +
		"It is used to find the best threshold at which to draw a boundary in a binary " +
		"classifier. This option is ignored if the classifier is not binary. In order to " +
		"determine the 'positive' class for the ROC, the class label name that is last in " +
		"sorted order is arbitrarily used."; 
	
	public static String CONVERGENCE_SETTINGS_HELP = 
		"<b>Kill Threshold</b>: Any weight is considered to be zero "+
		"if its absolute value becomes smaller than the kill threshold.  "+
		"If chosen sufficiently small, this should not alter the final "+
		"solution but simply accelerate the process of convergence; if "+
		"the value selected is much too large, however, it might possibly "+
		"alter the final solution. This only applies to the " +
		"non-component-wise update procedure and will be ignored for " +
		"the component-wise update procedure. <br><br>"+
		"<b>Convergence Tolerance</b>: The weight vector defining a "+
		"classifier is considered to have converged to a final solution "+
		"if the Euclidean difference between weight vectors in successive "+
		"iterations becomes smaller than the convergence tolerance.  Note "+
		"that this number may need to be scaled based on the length of "+
		"weight vector.<br><br>"+
		"<b>Maximum Iterations</b>: The classifier learning process "+
		"will stop, regardless of the degree of convergence, if the "+
		"number of iterations exceeds this value.";
	
	public static String PERFORMANCE_SETTINGS_HELP = 
		"<b>Adaptive Over-Relaxation</b>: For only the non-component-wise "+
		"algorithm, applies an over-relaxation technique whose goal "+
		"is to accelerate convergence to the optimum weights, but which "+
		"might possibly overshoot and thus increase the time required "+
		"for convergence.  It is not clear to us when this is a good "+
		"option and when it is not; your mileage may vary.<br><br>"+
		"<b>Cache Exponentials</b>: For only the component-wise algorithm, "+
		"this option creates a cache of computed exponentials that may "+
		"reduce the overall amount of computation time if the cache "+
		"becomes heavily used; it may also result in a small loss of "+
		"accuracy because of sooner rounding.<br><br>"+
		"<b>Cache Kernel Functions</b>: For use with cross-validation, "+
		"a kernel is applied to the same two points many times across "+
		"all folds of cross-validation, so this option creates a cache "+
		"of the results of applying the kernel to all pairs of points. "+
		"This requires normalization to be performed on the entire data "+
		"set beforehand, so data that is left out in each fold will still "+
		"be used in the normalization";  
		
	public static String CHOOSE_PANEL_HELP = 
		"The table displays a summary of all the combinations of "+
		"options that you have selected up until this point.  If there "+
		"are any combinations of options that you do not wish to "+
		"run, you may deselect those now before the runs are "+
		"executed.<br><br>"+
		"<b>Directory to Save Results to</b>: Enter the directory to which " +
		"results will be saved to. SMLR will create a summary file, named " +
		"'smlr.summary.testXXX.txt', for each test that is specified in " +
		"the 'Review Selections' panel, where XXX is the number of the test " +
		"being run. In addition, SMLR creates a log file called 'smlr.log.testXXX.txt'," +
		"which contains the information from each individual fold of " +
		"cross-validation. If cross-validation is not being used, the " +
		"log file will contain the information gathered from automatically " +
		"testing the classifier on the training set itself.";
	
	public static String SAVE_AND_LEARN_HELP = 
		"A <b>settings file</b> can be used to save the state of all "+
		"the information selected in the graphical version of SMLR.  "+
		"This settings file can then be used with the text (command "+
		"line) version of SMLR using the '-settings [FILENAME]' switch "+
		"from the command line.  Alternatively, the settings file can "+
		"also be loaded back into the graphical version of SMLR, and "+
		"the options selected in the settings file will be selected in "+
		"the interface for further manipulation.<br><br>" +
		"<b>Learn Classifier</b>: Will learn and then evaluate or use "+
		"a classifier for all the selected options above.";
}
