package edu.duke.cs.smlr.util;

import java.io.File;

import javax.swing.JFileChooser;

/**Static utility functions.
 *
 */
public final class Utilities {
	
	private static String dir = null;
	
	private Utilities() { }

	/**Creates a new JFileChooser in the current working directory.
	 * @return the JFileChooser
	 */
	public static JFileChooser newFileChooser() {
		if (dir == null)
			try {
				dir = System.getProperty("user.dir");
			} catch (SecurityException e) {}
			
		if (dir == null) return new JFileChooser();
    	else return new JFileChooser(dir);   			
	}

	public static void setDirectory(File currentDir) {
		dir = currentDir.getPath();
	}
}
