//TODO check repeated chunk / transposing
//TODO reimplement some of the inherited methods to be faster

package edu.duke.cs.smlr.util.matrix;

import java.io.Serializable;

import edu.duke.cs.smlr.learn.interfaces.IMatrix;

/**A matrix implementation that uses a primitive double array at its core.  Currently it
 * is lacking "inverse" code, so it's pretty useless.
 * 
 * @author Matt Edwards
 * 
 * @deprecated
 */

public class ArrayMatrix extends ManipMatrix 
		implements IMatrix, Cloneable, Serializable {

    protected double[][] elements;
        
    protected boolean transposed;
    protected boolean chunked;
    
    protected int rows;
    protected int columns;
    
    public ArrayMatrix() {
        super();
    }
    
    public ArrayMatrix(IMatrix other) {
        super(other);
    }
    
    public ArrayMatrix(int r, int c) {
      
        elements = new double[r][c];
        transposed = false;
        chunked = false;
                
        rows = r;
        columns = c;
    }

    /* (non-Javadoc)
     * @see edu.duke.cs.smlr.util.MathMatrix#transpose()
     */
    public IMatrix transpose() {
        transposed = !transposed;
        return this;
    }

    /* (non-Javadoc)
     * @see edu.duke.cs.smlr.util.AbstractMatrix#numRows()
     */
    public int numRows() {
        return transposed ? columns : rows;
    }

    /* (non-Javadoc)
     * @see edu.duke.cs.smlr.util.AbstractMatrix#numCols()
     */
    public int numCols() {
        return transposed ? rows : columns;
    }

    /* (non-Javadoc)
     * @see edu.duke.cs.smlr.util.AbstractMatrix#getQuick(int, int)
     */
    public double getQuick(int r, int c) {
        return transposed ? elements[c][r] : elements[r][c];
    }

    /* (non-Javadoc)
     * @see edu.duke.cs.smlr.util.AbstractMatrix#setQuick(double, int, int)
     */
    public void setQuick(double d, int r, int c) {
        if(transposed) elements[c][r] = d;
        else elements[r][c] = d;
    }

    /* (non-Javadoc)
     * @see edu.duke.cs.smlr.util.AbstractMatrix#like(int, int)
     */
    public IMatrix like(int r, int c) {
        return new ArrayMatrix(r, c);
    }
    
    /* (non-Javadoc)
     * @see edu.duke.cs.smlr.util.matrix.FullMatrix#inverse()
     */
    public IMatrix inverse() {
        throw new UnsupportedOperationException("Won't work");        
    }
    
}
