clear all;

load NEW_ORDER_180;

filename1 = filename60;
annot = annot_new;

n = 3;
N = 4;
k = 1;
figure();
flag = 1;
for i = 1:size(filename1,1),
    load (filename1(i,:));
    C(i,1) = 1-group_wrong/group_gene;
    clear group_gene;
    clear group_wrong;
    genes_check_inv = 1-genes_check;
    y_image_level = [predic genes_check_inv];
%     clear genes_check;
%     clear predic;
    good_gene = good_gene'; % if good_gene{i} is empty, that means the majority was wrong classification within that gen and mean{i} = 1;
    wrong_gene = wrong_gene';
    for j = 1:size(wrong_mean)-1,
        if (wrong_mean(j) <= 0.5)
            %fprintf('Good mean: %d \n',wrong_mean(j));
            v = mean(good_gene{j});
            if (v >= 0)
                marg = max(good_gene{j});
                m = 0;
            else
                marg = min(good_gene{j});
                m=1;
            end
            y_gene_level(j,:) = [marg m]; %#ok<AGROW>
            y_gene_level_mean(j,:) = [v m];
        else
            %fprintf('Wrong mean: %d \n',wrong_mean(j));
            v = mean(wrong_gene{j});
            if (v >= 0)
                marg = max(wrong_gene{j});
                m = 1;
            else
                marg = min(wrong_gene{j});
                m=0;
            end
            y_gene_level(j,:) = [marg m]; %#ok<AGROW>
            y_gene_level_mean(j,:) = [v m];
        end
    end
    if (i == n*N+1)
        figure();
        k = 1;
    elseif (i == 2*n*N+1)
        figure();
        k = 1;
    end
    subplot(n,N,k)
    g = gca;
    set(g, 'FontSize', 2);
    title(sprintf('ROC curve 60 features: \n Annotation term %s', annot{i}),'FontWeight','bold', 'FontSize', 2);hold on;
    ROCdata_image_level = roc_new(y_image_level, 0.05, 1, 1);
    AUC_image_level_60(i) = ROCdata_image_level.AUC;
    fprintf('AUC_image_level_annot_ %s = %d \n', filename1(i,:), AUC_image_level_60(i));
    ROCdata_gene_level = roc_new(y_gene_level, 0.05, 1, 2);
    AUC_gene_level_60(i) = ROCdata_gene_level.AUC;
    fprintf('AUC_gene_level_annot_ %s = %d \n', filename1(i,:), AUC_gene_level_60(i));
    ROCdata_gene_level_mean = roc_new(y_gene_level_mean, 0.05, 1, 3);
    AUC_gene_level_mean_60(i) = ROCdata_gene_level_mean.AUC;
    fprintf('AUC_gene_level_mean_annot_ %s = %d \n', filename1(i,:), AUC_gene_level_mean_60(i));
    legend('IL60', 'GL60', 'GL60M', 'Location', 'SouthEast');
    k = k+1;
end


filename2 = filename30;

k=1;
figure();
for i = 1:size(filename2,1),
    load (filename2(i,:));
    C(i,2) = 1-group_wrong/group_gene;
    clear group_gene;
    clear group_wrong;
    genes_check_inv = 1-genes_check;
    y_image_level = [predic genes_check_inv];
%     clear genes_check;
%     clear predic;
    good_gene = good_gene'; % if good_gene{i} is empty, that means the majority was wrong classification within that gen and mean{i} = 1;
    wrong_gene = wrong_gene';
    for j = 1:size(wrong_mean)-1,
        if (wrong_mean(j) <= 0.5)
            %fprintf('Good mean: %d \n',wrong_mean(j));
            v = mean(good_gene{j});
            if (v >= 0)
                marg = max(good_gene{j});
                m = 0;
            else
                marg = min(good_gene{j});
                m=1;
            end
            y_gene_level(j,:) = [marg m]; %#ok<AGROW>
            y_gene_level_mean(j,:) = [v m];
        else
            %fprintf('Wrong mean: %d \n',wrong_mean(j));
            v = mean(wrong_gene{j});
            if (v >= 0)
                marg = max(wrong_gene{j});
                m = 1;
            else
                marg = min(wrong_gene{j});
                m=0;
            end
            y_gene_level(j,:) = [marg m]; %#ok<AGROW>
            y_gene_level_mean(j,:) = [v m];
        end
    end
    if (i == n*N+1)
        figure();
        k = 1;
    elseif (i == 2*n*N+1)
        figure();
        k = 1;
    end
    subplot(n,N,k)
    g = gca;
    set(g, 'FontSize', 2);
    title(sprintf('ROC curve 30 features: \n Annotation term %s', annot{i}),'FontWeight','bold', 'FontSize', 2);hold on;
    ROCdata_image_level = roc_new(y_image_level, 0.05, 1, 1);
    AUC_image_level_30(i) = ROCdata_image_level.AUC;
    fprintf('AUC_image_level_annot_ %s = %d \n', filename2(i,:), AUC_image_level_30(i));
    ROCdata_gene_level = roc_new(y_gene_level, 0.05, 1, 2);
    AUC_gene_level_30(i) = ROCdata_gene_level.AUC;
    fprintf('AUC_gene_level_annot_ %s = %d \n', filename2(i,:), AUC_gene_level_30(i));
    ROCdata_gene_level_mean = roc_new(y_gene_level_mean, 0.05, 1, 3);
    AUC_gene_level_mean_30(i) = ROCdata_gene_level_mean.AUC;
    fprintf('AUC_gene_level_mean_annot_ %s = %d \n', filename2(i,:), AUC_gene_level_mean_30(i));
    legend('IL30', 'GL30', 'GL30M', 'Location', 'SouthEast');
    k = k+1;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

B = [1:size(filename2,1)];

figure();
bar(B,C,'group'); 

pos = get(gca,'Position');
set(gca,'Position',[pos(1), .2, pos(3) .65]);


Xt = 1:size(filename2,1);
Xl = [0 size(filename2,1)+1];
set(gca,'XTick',Xt,'XLim',Xl);



ax = axis; % Current axis limits
axis(axis); % Set the axis limit modes (e.g. XLimMode) to manual
Yl = ax(3:4); % Y-axis limits

t = text(Xt,Yl(1)*ones(1,length(Xt)),annot(1:size(filename2,1)));
set(t,'HorizontalAlignment','right','VerticalAlignment','top', ...
'Rotation',30,'FontWeight','bold', 'FontSize', 12);

% Remove the default labels
set(gca,'XTickLabel','');

% Get the Extent of each text object. This
% loop is unavoidable.
for i = 1:length(t)
ext(i,:) = get(t(i),'Extent');
end

% Determine the lowest point. The X-label will be
% placed so that the top is aligned with this point.
LowYPoint = min(ext(:,2));

% Place the axis label at this point
XMidPoint = Xl(1)+abs(diff(Xl))/2;
tl = text(XMidPoint,LowYPoint,'X-Axis Label', ...
'VerticalAlignment','top', ...
'HorizontalAlignment','center');


%%%%%%%%%%%%%%%%%%%%%%


figure();

D = [AUC_gene_level_mean_30' AUC_gene_level_mean_60'];
bar(B,D,'group'); 
title('The AUC of individual annotation terms from stage range 4-6 (SVM-light classification)');
legend('SVM-L-30M', 'SVM-L-60M', 'Location', 'NorthEast');

pos = get(gca,'Position');
set(gca,'Position',[pos(1), .2, pos(3) .65]);


Xt = 1:size(filename2,1);
Xl = [0 size(filename2,1)+1];
set(gca,'XTick',Xt,'XLim',Xl);



ax = axis; % Current axis limits
axis(axis); % Set the axis limit modes (e.g. XLimMode) to manual
Yl = ax(3:4); % Y-axis limits

t = text(Xt,Yl(1)*ones(1,length(Xt)),annot(1:size(filename2,1)));
set(t,'HorizontalAlignment','right','VerticalAlignment','top', ...
'Rotation',45,'FontWeight','bold', 'FontSize', 10, 'FontName', 'Courier');

% Remove the default labels
set(gca,'XTickLabel','');

% Get the Extent of each text object. This
% loop is unavoidable.
for i = 1:length(t)
ext(i,:) = get(t(i),'Extent');
end

% Determine the lowest point. The X-label will be
% placed so that the top is aligned with this point.
LowYPoint = min(ext(:,2));

% Place the axis label at this point
XMidPoint = Xl(1)+abs(diff(Xl))/2;
tl = text(XMidPoint,LowYPoint,'X-Axis Label', ...
'VerticalAlignment','top', ...
'HorizontalAlignment','center');


%%%%%%%%%%%%%%%%%%%%%%

figure();

E = [AUC_image_level_30' AUC_gene_level_30' AUC_gene_level_mean_30' AUC_image_level_60' AUC_gene_level_60' AUC_gene_level_mean_60'];
bar(B,E,'group'); 
legend('IL30', 'GL30', 'GL30M', 'IL60', 'GL60', 'GL60M','Location', 'NorthEast');

pos = get(gca,'Position');
set(gca,'Position',[pos(1), .2, pos(3) .65]);


Xt = 1:size(filename2,1);
Xl = [0 size(filename2,1)+1];
set(gca,'XTick',Xt,'XLim',Xl);



ax = axis; % Current axis limits
axis(axis); % Set the axis limit modes (e.g. XLimMode) to manual
Yl = ax(3:4); % Y-axis limits

t = text(Xt,Yl(1)*ones(1,length(Xt)),annot(1:size(filename2,1)));
set(t,'HorizontalAlignment','right','VerticalAlignment','top', ...
'Rotation',30,'FontWeight','bold', 'FontSize', 12);

% Remove the default labels
set(gca,'XTickLabel','');

% Get the Extent of each text object. This
% loop is unavoidable.
for i = 1:length(t)
ext(i,:) = get(t(i),'Extent');
end

% Determine the lowest point. The X-label will be
% placed so that the top is aligned with this point.
LowYPoint = min(ext(:,2));

% Place the axis label at this point
XMidPoint = Xl(1)+abs(diff(Xl))/2;
tl = text(XMidPoint,LowYPoint,'X-Axis Label', ...
'VerticalAlignment','top', ...
'HorizontalAlignment','center');


%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% SVM-light (30), SVM-light(60) and SMLR results (60) and SVM-light(100) and SVM-light(50)%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load NEW_ORDER_180;

filename1 = filename12;
filename2 = filename1;
annot = annot_new;
B = [1:size(filename2,1)];

figure();

load AUC_gene_100; % only with one resolution, 100 factors.
load AUC_gene_180; % all three resolutions, 180 factors.
SMLR = SMLR_NEW; % SMLR results are obtained using a Java application.
SMLR_180 = [0.7932 0.7942 0.8321 0.8023 0.7732 0.7475 0.7487 0.7378 0.7465 0.7189 0.7102 0.7085 0.5732 0.6132 0.7045 0.7558 0.7491 0.7338 0.7712 0.7112 0.8421 0.6079 0.6448 0.9112];
D = [SMLR' AUC_gene_level_mean_30' AUC_gene_level_mean_60' AUC_gene_level_mean_100' AUC_gene_level_mean_180' SMLR_180'];
bar(B,D,'group'); hold on;
legend( 'SMLR-60', 'SVM-30', 'SVM-60', 'SVM-100-(100 factors, one resolution)', 'SVM-180-(180 factors, one resolution)', 'SMLR-180', 'Location', 'NorthEast');

pos = get(gca,'Position');
set(gca,'Position',[pos(1), .2, pos(3) .65]);


Xt = 1:size(filename2,1);
Xl = [0 size(filename2,1)+1];
set(gca,'XTick',Xt,'XLim',Xl);



ax = axis; % Current axis limits
axis(axis); % Set the axis limit modes (e.g. XLimMode) to manual
Yl = ax(3:4); % Y-axis limits

t = text(Xt,Yl(1)*ones(1,length(Xt)),annot(1:size(filename2,1)));
set(t,'HorizontalAlignment','right','VerticalAlignment','top', ...
'Rotation',45,'FontWeight','bold', 'FontSize', 10, 'FontName', 'Courier');

% Remove the default labels
set(gca,'XTickLabel','');

% Get the Extent of each text object. This
% loop is unavoidable.
for i = 1:length(t)
ext(i,:) = get(t(i),'Extent');
end

% Determine the lowest point. The X-label will be
% placed so that the top is aligned with this point.
LowYPoint = min(ext(:,2));

% Place the axis label at this point
XMidPoint = Xl(1)+abs(diff(Xl))/2;
tl = text(XMidPoint,LowYPoint,'X-Axis Label', ...
'VerticalAlignment','top', ...
'HorizontalAlignment','center');

%%%%%%%%%%%%%%%%%%%%%%

