% % % % % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % % % % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % % % % %%% SVM analysis:
% filename1 = ['279'; '275'; '270'; '285'; '267'; '284'; '263'; '254'; '272'; '286'; '281'; '288'; '289'; '271';  '290'; '423'; '449'; '269'; '277'; '424'; '357'; '283'; '261'; '386']; % the entire set of 24 annotations;
load ANNOTATIONS_FRUITFLY_TOM;
load IMAGES_ALL_ANGLES_46_NEW;

load NEW_ORDER;
filename1 = filename1_new; % the ordered list of annotation terms, within genes.


for kk = 1:5,
%for kk = 1:size(filename1,1),
    annotation_id = filename1(kk,:); % the annotation that we build a SVM for; this gives me the ground truth list for each annotation term;
    fprintf('Current annotation term:  %s',annotation_id);
    cont = 1;
    genes = [];
    genes_check = [];
    for i = 1:size(genes_numbers_according_picture,1),
        fprintf('Current index: %d \n',i);
        flag = 0;
        text1 = genes_numbers_according_picture{i};
        LL1 = length(text1);
        text2 = text1(3:LL1);
        for j = 1:size(ANNOT_TOM_GENES_2,1),
            text3 = ANNOT_TOM_GENES_2{j};
            LL3 = length(text3);
            text4 = text3(3:LL3);
            text22 = str2num(text2);
            text44 = str2num(text4);
            %if (length(text2) == length(text4))
                if (text22 == text44)
                    fprintf('Matching gene: %s \n',text1);
                    name = ANNOT_TOM_ID_2{j};
                    FF = textscan(name,'%s %s %s %s %s %s %s %s %s %s', 'Delimiter', ';');
                    for k = 1:size(FF,2),
                        number = FF{k};
                        if (length(number) ~= 0)
                            a = number{1};
                            if (length(annotation_id) == length(a))
                                if (a == annotation_id)
                                    flag =1;
                                    fprintf('FLAG\n');
                                end
                            end
                        end
                    end
                end
            %end
        end
        if (flag == 1)
            genes_check(i) = 1;
        else
            genes_check(i) = 0;
        end
    end
    genes_check = genes_check';
    
    

    genes_check_light = [];
    for i = 1:size(genes_check,1),
        if (genes_check(i) == 0)
            genes_check_light(i) = -1;
        else
            genes_check_light(i) = 1;
        end
    end
    genes_check_light = genes_check_light';

    %% factors are concatenated in a vector, before the SVM analysis:
    load X_5_Berkeley_ALL_ANGLES_NEW_k30_1.mat;
    SSS = size(A,2);
    B = A(:,[2:SSS]);
    clear A;
    A = B;
    clear B;
    weights = A;
    clear A;

    load X_4_Berkeley_ALL_ANGLES_NEW_k50_1.mat;
    SSS = size(A,2);
    B = A(:,[2:SSS]);
    clear A;
    A = B;
    clear B;
    weights = [weights A];
    clear A;

    load X_3_Berkeley_ALL_ANGLES_NEW_k100_1;
    %load X_3_Berkeley_ALL_ANGLES_NEW_k50_1;
    SSS = size(A,2);
    B = A(:,[2:SSS]);
    clear A;
    A = B;
    clear B;
    weights = [weights A];
    %weights = [weights A];
    clear A;

    filename2 = ['SVM_DATA_NEW_180_' annotation_id];
    %filename2 = ['SVM_DATA_NEW_' annotation_id];
    save(filename2, 'weights', 'genes_check', 'genes_check_light');
    
    count_wrong = 0;
    for i = 1:size(weights,1), % LOO analysis
        fprintf('SVM analysis: Current iteration:    %d \n',i);
        datatrain = weights([1:i-1 i+1:1231],:);
        datatest = weights(i,:);
        ground_truth = genes_check_light(i);
        groups = genes_check_light([1:i-1 i+1:1231],:);
        %svmStruct = svmtrain(datatrain,groups);
        %svmStruct = svmtrain(datatrain,groups,'BOXCONSTRAINT',10);
        %svmStruct = svmtrain(datatrain,groups,'KERNEL_FUNCTION','rbf');
        %model = svmlearn(datatrain, groups, '-t 1 -g 0.3 -c 0.5 -j 1000'); % polynomial kernel;
        model = svmlearn(datatrain, groups, '-t 1 -g 0.3 -c 0.5'); % polynomial kernel;
        [err, predictions] = svmclassify(datatest, ground_truth, model);
        predic(i) = predictions;
        fprintf('Error: %d \n',err);
        if (predictions < 0)
            labels = -1;
        else
            labels = 1;
        end
        %classes = svmclassify(svmStruct, datatest);
        if (labels ~= ground_truth)
            fprintf('Wrong classification \n');
            count_wrong = count_wrong + 1;
        else
            fprintf('Good classification \n');
        end

        RESULTS{i} = [labels ground_truth];
        clear datatrain;
        clear datatest;
        clear ground_truth;
        clear groups;
        clear svmStruct;
        clear predictions;
        clear model;
        %pause();
    end
    predic = predic';
    RESULTS = RESULTS';
    
    cont = 0;
    wr = 0;
    group_gene = 0;
    good = [];
    wrong = [];
    for i = 1:size(genes_numbers_according_picture,1)-1,
        word1 = genes_numbers_according_picture{i};
        word2 = genes_numbers_according_picture{i+1};
        if (length(word1) == length(word2))
            if (word1 == word2)
                cont = cont+1;
                res1 = RESULTS{i}(1);
                res2 = RESULTS{i}(2);
                if (res1 ~= res2)
                    wr = wr+1;
                    wrong = [wrong predic(i)];
                else
                    good = [good predic(i)];
                end

            else
                fprintf('Current index: %d \n',i);
                fprintf('Gene_group: %s \n',word1);
                res1 = RESULTS{i}(1);
                res2 = RESULTS{i}(2);
                if (res1 ~= res2)
                    wr = wr+1;
                    wrong = [wrong predic(i)];
                else
                    good = [good predic(i)];
                end
                group_gene = group_gene+1;
                mean(group_gene) = wr/(cont+1);
                good_gene{group_gene} = good;
                wrong_gene{group_gene} = wrong;
                cont = 0;
                wr = 0;
                good = [];
                wrong = [];
                fprintf('Mean_wrong: %d \n \n \n',mean(group_gene));

            end
        else
            fprintf('Current index: %d \n',i);
            fprintf('Gene_group: %s \n',word1);
            res1 = RESULTS{i}(1);
            res2 = RESULTS{i}(2);
            if (res1 ~= res2)
                wr = wr+1;
                wrong = [wrong predic(i)];
            else
                good = [good predic(i)];
            end
            group_gene = group_gene+1;
            mean(group_gene) = wr/(cont+1);
            good_gene{group_gene} = good;
            wrong_gene{group_gene} = wrong;
            cont = 0;
            wr = 0;
            good = [];
            wrong = [];
            fprintf('Mean_wrong: %d \n \n \n',mean(group_gene));

        end
    end
    
    mean(group_gene+1) = 0; 
    mean = mean';
    
    group_wrong = 0;
    for i = 1:size(mean,1),
        a = mean(i);
        if (a>0.5)
            group_wrong = group_wrong+1;
        end
    end

    wrong_mean = mean;

    filename = ['SVM_NEW_180_' annotation_id];
    %filename = ['SVM_NEW_' annotation_id];
    save(filename, 'wrong_gene', 'good_gene', 'predic', 'RESULTS', 'count_wrong', 'genes_check', 'genes_check_light', 'weights', 'group_gene', 'group_wrong', 'wrong_mean', 'filename1', 'genes_list', 'genes_list_according_picture', 'genes_numbers_according_picture', 'picture_list', 'picture_list_new', 'gene', 'gene_annot', 'gene_name', 'gene_stage');

end

%%%%%% SVM processing complete.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%